// ************************************************************
// * Program        : buzzer.c
// * Description    : Demo program for buzzer function
// *
// * Revision       : 1.0
// * Date           : 08/24/2008          Advantech Co., Ltd.
// *************************************************************

#include "../include/unodio.h"	

int main ( int argv, char **arg )
{
   int ret;
   int argu;
  
   if(argv != 2) 
   {
      printf("Usage: %s [options]\n", arg[ 0 ]);
      printf("options: 0 -- turn off\n");
      printf("         1 -- continue beep\n");
      printf("         3 -- short beep\n");
      printf("         5 -- middle beep\n");
      printf("         7 -- long beep\n");
      return 0;
   }
  
   argu = atoi(arg[1]);
  
   if(argu > 7 
      || argu < 0 
      || argu % 2 != 1) 
   {
      if(argu != 0) 
      {
         printf("error argument!\n");
         return 1;
      }
   }
	  
   ret = DeviceOpen();
   if ( ret < 0 )
   {
      printf ("Can not open device\n");
      return 1;
   }
  
   ret = BuzzerEnable(argu);
   if (ret == -1 && errno == ENOTSUP)
   {
      printf("This funtion do not support\n");
      return 1; 
   }

   DeviceClose();
   return 0;
}

 
