// *****************************************************************
// * Program        : digin.c
// * Description    : Demo program for digital input function
// *
// * Revision       : 1.0
// * Date           : 08/24/2008     Advantech Co., Ltd.
// *****************************************************************

#include "../include/unodio.h"

int main ( void )
{	
   int usState;
   int i, ret;
   int  DIChannelNum;
   int  DOChannelNum;
   int  bSupportFunc;
   //Step 1: Display hardware and software settings for running this example
   printf("------ Digital input via port output and bit number ------\n\n");

   //Step 2: Open device
   ret = DeviceOpen();		
   if (ret == -1)
   {
      printf("Device Open error!\n");
      return 1;
   }
	
   GetDeviceInfor(&DIChannelNum,&DOChannelNum,&bSupportFunc);
	
   // Step 3: Read state from the specified channel
   ret = DIReadPortByte(0, &usState);
   if (ret != 0) 
   {
      return 0;
   }
    
   printf("\nReading data via port (port 0) = 0x%x\n\n", usState);

   // Step 4: Read State from each bit from 0 to 3
   if (DIChannelNum >= 8 )
   { 
      DIChannelNum = 8;
   }
   else
   {
      DIChannelNum = 4;
   }
   for ( i=0 ; i < DIChannelNum; i++ ) 
   {
      ret = DIReadBit(0 , i , &usState);
      if ( ret != 0 ) 
      {
         return 0;
      }

      printf("Reading data via bits (Bit %d) = 0x%1X\n", i, usState);
   }

   // Step 5: Close device
   ret = DeviceClose();

   printf("\nPress any key to exit....");
   getchar();
   return 0;
}
