// *****************************************************************************
// * Program        : digout.c
// * Description    : Demo program for digital output function
// *
// * Revision       : 1.0
// * Date           : 08/24/2008   Advantech Co., Ltd.
// *****************************************************************************

#include "../include/unodio.h"

int main ( void )
{
   int usState;
   int i, ret;
   int  DIChannelNum;
   int  DOChannelNum;
   int  bSupportFunc;

   //Step 1: Display hardware and software settings for running this example
   printf("------ Digital output via port output and bit number ------\n\n");

   //Step 2: Open device
   ret = DeviceOpen();
   if (ret == -1)
   {
      printf("Device Open error!\n");
      return 1;
   }
    
   // Step 3: Get the DIO channel count
   GetDeviceInfor(&DIChannelNum,&DOChannelNum,&bSupportFunc);
   printf("The UNO has %d DI channel and %d DO channel\n ", 
      DIChannelNum,
      DOChannelNum);    
	
   // Step 4: Read back the current DO value
   ret = DOGetCurrentByte(0, &usState);
   if (ret != 0)
      return 0;
    
   printf("\nDO port 0 current value =0x%x\n", usState);	

   // Step 5: Read State from each bit from 0 to 3
   for (i = 0; i < DOChannelNum ; i++) 
   {
      ret = DOGetCurrentBit(0 , i , &usState);
      printf("DO bit %d current state = 0x%1X\n", i, usState);
   }

   // Step 6: Prepare the write value 0x00 and 0xff
   printf("\nPrepare to write data, press any key to continue...\n\n");
   getchar();
	
   printf("\nWrite port value to 0x00, press any key to continue....\n");
   getchar();
   ret = DOWritePortByte(0 , 0xff , 0x00);
	
   printf("\nWrite port value to 0xff, press any key to continue....\n");
   getchar();
   ret = DOWritePortByte(0 , 0xff , 0xff);

   // Step 7: Write bit from 0 to DOChannelNum-1
   for (i=0 ; i < DOChannelNum ; i++) 
   {
      ret = DOWriteBit(0 , i , i%2);
      if (ret != 0)
         return 0;
      printf("Write value 0x%1x  to  (Bit %d)\n", i%2, i);
   }	

   // Step 8: Close device
   printf ("Close Device\n");
   ret = DeviceClose();

   printf("\nPress any key to exit....");
   getchar();

   return 0;
}
