// *************************************************************************
// * Program		: diint_uno2679.c
// * Description	: Demo program for digital input with interrupt function
// *
// * Revision		: 1.0
// * Date		: 08/24/2008  Advantech Co., Ltd.
// *************************************************************************
#include <sys/time.h>
#include <sys/types.h>
#include "../include/unodio.h"

struct timespec g_init_budget = { 5, 0 };
struct timespec g_repl_period = { 10, 0 };

#define MY_REPL_PERIOD g_repl_period
#define MY_INIT_BUDGET g_init_budget
#define MY_MAX_REPL 10

static pthread_t han_in_id;

static int di0int = 0;
static int di1int = 0;
static int di2int = 0;
static int di3int = 0;
static int di4int = 0;
static int di5int = 0;
static int di6int = 0;
static int di7int = 0;
static int di8int = 0;

void * handle_interrupt(void * arg)
{
   int event_type;
   struct timeval tvDI0Old, tvDI0New; 
   struct timeval tvDI1Old, tvDI1New;
   struct timeval tvDI2Old, tvDI2New;
   struct timeval tvDI3Old, tvDI3New;
   struct timeval tvDI4Old, tvDI4New;
   struct timeval tvDI5Old, tvDI5New;
   struct timeval tvDI6Old, tvDI6New;
   struct timeval tvDI7Old, tvDI7New;
   struct timeval tvDI8Old, tvDI8New;
   gettimeofday( &tvDI0Old, NULL );
   gettimeofday( &tvDI1Old, NULL );
   gettimeofday( &tvDI2Old, NULL );
   gettimeofday( &tvDI3Old, NULL );
   gettimeofday( &tvDI4Old, NULL );
   gettimeofday( &tvDI5Old, NULL );
   gettimeofday( &tvDI6Old, NULL );
   gettimeofday( &tvDI7Old, NULL );
   gettimeofday( &tvDI8Old, NULL );
   while(1)
   {
      event_type = CheckEvent( 1 );
      
      switch( event_type ) 
      {
         case EVT_DI0:
            di0int ++;
            gettimeofday(&tvDI0New,NULL);
            if (tvDI0New.tv_sec-tvDI0Old.tv_sec >= 1)
            {
               printf("DI0 interrupt ocurred %.3f/s\n",
                  (float)di0int/(tvDI0New.tv_sec-tvDI0Old.tv_sec));
               tvDI0Old = tvDI0New;
               di0int = 0;
            }
         break;
         case EVT_DI1:
            di1int ++;
            gettimeofday(&tvDI1New,NULL);
            if (tvDI1New.tv_sec-tvDI1Old.tv_sec >= 1)
            {
               printf("DI1 interrupt ocurred %.3f/s\n",
                  (float)di1int/(tvDI1New.tv_sec-tvDI1Old.tv_sec));
               tvDI1Old = tvDI1New;
               di1int = 0;
            }
         break;

         case EVT_DI2:
            di2int ++;
            gettimeofday(&tvDI2New,NULL);
            if (tvDI2New.tv_sec-tvDI2Old.tv_sec >= 1)
            {
               printf("DI2 interrupt ocurred %.3f/s\n",
                  (float)di2int/(tvDI2New.tv_sec-tvDI2Old.tv_sec));
               tvDI2Old = tvDI2New;
               di2int = 0;
            }
         break;
         case EVT_DI3:
            di3int ++;
            gettimeofday(&tvDI3New,NULL);
            if (tvDI3New.tv_sec-tvDI3Old.tv_sec >= 1)
            {
               printf("DI3 interrupt ocurred %.3f/s\n",
                  (float)di3int/(tvDI3New.tv_sec-tvDI3Old.tv_sec));
               tvDI3Old = tvDI3New;
               di3int = 0;
            }
         break;
         case EVT_DI4:
            di4int ++;
            gettimeofday(&tvDI4New,NULL);
            if (tvDI4New.tv_sec-tvDI4Old.tv_sec >= 1)
            {
               printf("DI4 interrupt ocurred %.3f/s\n",
                  (float)di4int/(tvDI4New.tv_sec-tvDI4Old.tv_sec));
               tvDI4Old = tvDI4New;
               di4int = 0;
            }
         break;
         case EVT_DI5:
            di5int ++;
            gettimeofday(&tvDI5New,NULL);
            if (tvDI5New.tv_sec-tvDI5Old.tv_sec >= 1)
            {
               printf("DI5 interrupt ocurred %.3f/s\n",
                  (float)di5int/(tvDI5New.tv_sec-tvDI5Old.tv_sec));
               tvDI5Old = tvDI5New;
               di5int = 0;
            }
         break;
         case EVT_DI6:
            di6int ++;
            gettimeofday(&tvDI6New,NULL);
            if (tvDI6New.tv_sec-tvDI6Old.tv_sec >= 1)
            {
               printf("DI6 interrupt ocurred %.3f/s\n",
                  (float)di6int/(tvDI6New.tv_sec-tvDI6Old.tv_sec));
               tvDI6Old = tvDI6New;
               di6int = 0;
            }
         break;
         case EVT_DI7:
            di7int ++;
            gettimeofday(&tvDI7New,NULL);
            if (tvDI7New.tv_sec-tvDI7Old.tv_sec >= 1)
            {
               printf("DI7 interrupt ocurred %.3f/s\n",
                  (float)di7int/(tvDI7New.tv_sec-tvDI7Old.tv_sec));
               tvDI7Old = tvDI7New;
               di7int = 0;
            }
         break;
         case EVT_DI8:
            di8int ++;
            gettimeofday(&tvDI8New,NULL);
            if (tvDI8New.tv_sec-tvDI8Old.tv_sec >= 1)
            {
               printf("DI8 interrupt ocurred %.3f/s\n",
                  (float)di8int/(tvDI8New.tv_sec-tvDI8Old.tv_sec));
               tvDI8Old = tvDI8New;
               di8int = 0;
            }
         break;
         case EVT_TIMEOUT:
            printf("time out!\n");
            break;
      }
   }
}

int main ( void )
{ 
   int EventType = 0;
   int ret;   
   //Step 1: Display hardware and software settings
   printf("------ DI interrupt function testing ------\n\n");
   
   //Step 2: Open device
   ret = DeviceOpen();  
   if (ret < 0 )
   {
      printf("Device Open error!\n");
      return 1;
   }
    	
   // Step3: configure the DI interrupt for rising edge
   EventType = ADS_EVT_DI0 
	| ADS_EVT_DI1	
	| ADS_EVT_DI2	
	| ADS_EVT_DI3	
	| ADS_EVT_DI4	
	| ADS_EVT_DI5	
	| ADS_EVT_DI6	
	| ADS_EVT_DI7	
	| ADS_EVT_DI8;	

   // Step4: enable and start the event function
   if (EventEnable(EventType, 1, 1))
      return 1;

   // Step5: exit while pressing any key
   printf("Input signal into DI0 ~ DI8, let the system generates interrupt!\n");
   printf("Press 'q' to exit.\n");
   ret = pthread_create( &han_in_id, NULL, handle_interrupt, NULL ); 	
   if ( ret != EOK )
   {
      printf("create thread failure!\n");
      perror( "pthread_create interrrupt:" );    
      return EXIT_FAILURE;
   } 
   while ( 1 )
   { 
      if ( getchar() == 'q' )
      {   
         pthread_cancel(han_in_id);			
         break;
      } 
      delay( 1000 );
   }      	
        
   // Step6: disable and close the event function
   EventType = ADS_EVT_DI0 
             | ADS_EVT_DI1
             | ADS_EVT_DI2
             | ADS_EVT_DI3
             | ADS_EVT_DI4
             | ADS_EVT_DI5
             | ADS_EVT_DI6
             | ADS_EVT_DI7
             | ADS_EVT_DI8;
   if (EventEnable(EventType, 0, 1))
      return 1;

   // Step7: close device handle
   DeviceClose();	
   return 0;
}
