// ***********************************************************************
// * Program        : led.c
// * Description    : Demo program for led function
// *
// * Revision       : 1.0
// * Date           : 09/11/2008          Advantech Co., Ltd.
// ***********************************************************************

#include "../include/unodio.h"	

int main ( int argv, char **arg )
{
   int ret;
   int argu;
  
   if(argv != 2) 
   {
      printf("Usage: %s [options]\n", arg[ 0 ]);
      printf("options: 0 -- turn off\n");
      printf("         1 -- light on\n");
      printf("         3 -- fast flickering\n");
      printf("         5 -- normal flickering\n");
      printf("         7 -- slow flickering\n");
      return 0;
   }
  
   argu = atoi(arg[1]);
  
   if(argu > 7 || argu < 0 || argu % 2 != 1) 
   {
      if(argu != 0) 
      {
         printf("error argument!\n");
         return 0;
      }
   }
	  
   ret = DeviceOpen();
   if ( ret == -1 )
   {
      printf("Device Open error!\n");
      return 1;
   }
  
   ret = LedEnable(argu);
   if (ret == -1 && errno == ENOTSUP)
   {
      printf("This funtion do not support\n");
      return -1; 
   }
	
   DeviceClose();
  
   return 1;
}

 
