// ************************************************************************
// * Program        : portio.c
// * Description    : Demo program to write/read a port value function
// *
// * Revision       : 1.0
// * Date           : 08/28/2008          Advantech Co., Ltd.
// ***********************************************************************

#include "../include/unodio.h"
#define SUCCESS 0

int main ( void )
{
   int  dwErrCde;
   int  byData;
 	
   //Step 1: Display hardware and software settings for running this example
   printf("Input/Output port function testing....\n\n");

   //Step 3: Open device
   dwErrCde = DeviceOpen();
   if (dwErrCde == -1)
   {
      printf("Device Open error!\n");
      return 1;
   }

   //Step 4: write some value to offset 1
   //firstly write 0x5 value, then readback this value.
   dwErrCde = WritePortByte(1, 0x5);
   if ( dwErrCde == -1 )
   {
      return 0;
   }
   printf("\nWrite 0x5 to offset 1\n");		    
   getchar();
    
   //Step 5: read some value from offset 1
   dwErrCde = ReadPortByte(1, &byData);
   printf("\nReadback data from offset 1, its value is 0x%x\n", byData);		        
   getchar();

   //Step 6: write some value to offset 1
   dwErrCde = WritePortByte(1, 0x0);
   printf("\nWrite 0x00 to offset 1\n");		    
   getchar();
    
   //Step 7: read some value from offset 1
   dwErrCde = ReadPortByte(1, &byData);
   printf("\nReadback data from offset 1, its value is 0x%x\n", byData);		        
   getchar();

   //Step 8: write some value to offset 1
   dwErrCde = WritePortByte(1, 0xf);
   printf("\nWrite 0xf to offset 1\n");		    
   getchar();
    
   //Step 9: read some value from offset 1
   dwErrCde = ReadPortByte(1, &byData);
   printf("\nReadback data from offset 1, its value is 0x%x\n", byData);		        
   getchar();

   if (dwErrCde != SUCCESS)
      return 1;

   // Step 10: Close device
   dwErrCde = DeviceClose();

   return 0;
}
