// ***********************************************************************
// * Program        : power.c
// * Description    : Demo program for retriving power status function
// *
// * Revision       : 1.0
// * Date           : 08/24/2008          Advantech Co., Ltd.
// ***********************************************************************

#include "../include/unodio.h"

int main ( void )
{	
   int usState;
   int ret;
   char ch;

   //Step 1: 
   printf("------ Get power status test example ------\n\n");

   //Step 2: Open device
   ret = DeviceOpen();		
   if (ret == -1)
   {
      printf("Device Open error!\n");
      return 1;
   }
	
   while ( 1 )	
   {
      ret = GetPowerStatus( &usState );
      if ( usState & 0x1 )
      {
         printf(" Power 1 is ok!\n");
      }
      else
      {
         printf(" Power 1 is fail!\n");
      }

      if ( usState & 0x2 )
      {
         printf(" Power 2 is ok!\n");
      }
      else 
      {
         printf(" Power 2 is fail!\n");
      }

      if ( usState & 0x4 )
      {
         printf(" Power is fail!\n");
      }
      else
      {
         printf(" Power is ok!\n");
      }
		
      printf(" Press 'Q' or 'q' to exit, other to continue...\n");
      ch = getchar();
      if ( ch == 'q'|| ch == 'Q')
      {
         break;
      }
   }

   // Step 3: Close device
   ret = DeviceClose();
   return 0;
}
