// ***********************************************************************
// * Program        : led.c
// * Description    : Demo program for led function
// * Boards Supp.   : only for UNO-1171
// *
// * Revision       : 1.0.0.1
// * Date           : 03/26/2010         Advantech Co., Ltd.
// ***********************************************************************

#include "unodio.h"	/* Library function declaration	*/

int main ( int argv, char **arg )
{
   int ret;

  int  usLedData;
  int  mask = 0xff;
	  
   //Step 1: Display hardware and software settings for running this example
   printf("Program LED function testing....\n\n");

   //Step 2: Open device
   ret = DeviceOpen();
   if (ret < 0)	
   {
      //printf("Device Open error!\n");
      return 1;
   }	

   //Step 3: Read Program Led 
   ret = ProgramLedRead(&usLedData);
   if (ret == -1 && errno == ENOTSUP)
   {
      printf("This funtion do not support\n");
      return -1; 
   }

   printf("\nProgram LED value: %2x\n", usLedData);	
   printf("\npress any key to continue ...\n");	
   getchar();

 
   //UNO-1171 can set the program led mode
   //To set program led as fast flicker
   ret = ProgramLedModeConfig(LED_FAST);
   //LED0 use the fast flicker mode 
   ret = ProgramLedModeEnable(0, LED_ON);
   //LED1 don't use mode 
   ret = ProgramLedModeEnable(1, LED_DISABLE);

   //Step 4: Write 0xFF to Program Led
   usLedData = 0xFF;
   ret = ProgramLedWrite(usLedData,mask);

   printf("\nWrite 0xFF to Program LED\n");	
   printf("\npress any key to continue ...\n");	
   getchar();

   // Step 5: Close device
   DeviceClose();

   return 0;
}

 
