#ifndef UNODIOIOCTL_H
#define UNODIOIOCTL_H

struct rdata_t{
   int port;                  //port and countershourt
   int bit;                     // or gata period
   int state;                 // port value and count value
};
struct sdata_t{
   int  status;
   int overflow_data;         //or countet num
};
typedef union ad_rsdata_t{
   struct rdata_t i;
   struct sdata_t o;
} rsdata_t;

struct counter_rdata_t{
   int counter;
   float period;
   float UpCycle;
   short usCTRGate;
};
struct counter_sdata_t{           // for extend
   int counter;
   unsigned long timelapse;
   unsigned long cntnum;
   long kernelhz;
};

typedef union ad_counter_rsdata_t{
   struct counter_rdata_t i;
   struct counter_sdata_t o;
} counter_rsdata_t;

//Command used by ioctl system call
#define UNO_DIO_IOC_MAGIC   'd'  // use 'd' as magic number

#define AD_DIO_READ_PORT_BYTE       __DIOTF(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 1,int)
#define AD_DIO_WRITE_PORT_BYTE      __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 2,struct rdata_t)
#define AD_DIO_READ_BIT             __DIOTF(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 3,rsdata_t)
#define AD_DIO_WRITE_BIT            __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 4,struct rdata_t)
#define AD_DIO_GET_DO_BYTE          __DIOF(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 5,int)
#define AD_DIO_GET_DO_BIT           __DIOTF(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 6,rsdata_t)
#define AD_COUNTER_TIMER_START      __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 7,struct rdata_t)
#define AD_COUNTER_EVENT_START      __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 8,struct rdata_t)
#define AD_COUNTER_EVENT_READ       __DIOTF(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 9,rsdata_t)
#define AD_COUNTER_FREQ_START       __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 10,struct rdata_t)
#define AD_COUNTER_FREQ_READ        __DIOTF(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 11,counter_rsdata_t)
#define AD_COUNTER_PULSE_START      __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 12,struct counter_rdata_t)
#define AD_COUNTER_RESET            __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 13,int)
#define AD_COUNTER_CLOCK_CFG        __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 14,int)
#define AD_COUNTER_CFG              __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 15,struct counter_sdata_t)
#define AD_COUNTER_GATE_SET         __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 16,struct rdata_t)
#define AD_COUNTER_MONITOR          __DIOTF(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 17, rsdata_t)
#define AD_WRITE_PORT_BYTE          __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 18,struct rdata_t)
#define AD_READ_PORT_BYTE           __DIOTF(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 19, rsdata_t)
#define AD_EVENT_CFG                __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 20,struct rdata_t)
#define AD_EVENT_ENABLE             __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 21,struct rdata_t)
#define AD_LED_ENABLE               __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 22,int)
#define AD_BUZZER_ENABLE            __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 23,int)
#define AD_PROGRAMLED_WRITE               __DIOT(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 24,int)
//#define AD_GETEVENT               __DIOF(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 24,int)
#define AD_GETPOWER                 __DIOF(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 25,int)
#define AD_GETIOTYPE               __DIOF(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 26,int)
#define AD_PROGRAMLED_READ               __DIOF(_DCMD_CHR,UNO_DIO_IOC_MAGIC + 27,int)
#define AD_UNO_DIO_IOC_MAXNR   27

#endif
